#ifndef _DOMAIN_H

#include "row.h"

typedef struct {
	int Nx, Ny, Nguard;
	double *x, *y;
	double **dens;	
	double **ener;	
	double **pres;	
	double **temp;	
	double **momx;	
	double **momy;	
	
	short int alloced; 
	int   enerflag;
} domain_t;

#define MAX_DOMAINSIZE 10000
#define NVARS  6

#define DENSVAR 0
#define ENERVAR 1
#define PRESVAR 2
#define TEMPVAR 3
#define MOMXVAR 4
#define MOMYVAR 5

#define XDIR -1
#define YDIR +1

int init_domain(domain_t *d, int nx, int ny, int nguard, double startx, double starty, double endx, double endy);
int free_domain(domain_t *d);
int domain_ener_tot_to_internal(domain_t *d);
int domain_ener_internal_to_tot(domain_t *d);
int domain_extract_row(domain_t *d, row_t *r, int rowcol, int direction);
int domain_insert_row(domain_t *d, row_t *r, int rowcol, int direction);

int nancheck(domain_t *d, int tag);

#define _DOMAIN_H 1
#endif
