/*
 * eos.h 
 *  contains definitions for eos routines
 *  and eos constants
 */

#ifndef _EOS_H			
#define	EOS_GASCONST 8.3144e+7
#define EOS_GAMMA    1.4
#define EOS_ABAR     1.0

#include "domain.h"
#include "row.h"

int forward_eos(int n, double *dens, double *ener, double *pres, double *temp);
int forward_eos_row(row_t *r);
int backward_dp_eos(int n, double *dens, double *pres, double *temp, double *ener);
int backward_dp_eos_row(row_t *r);
int domain_forward_eos(domain_t *d);
int domain_backward_dp_eos(domain_t *d);
int domain_timestep(domain_t *d, double *dt);
double eos_gamma(void);

#define _EOS_H 1
#endif


