#include <mpi.h>
#include "ljtypes.h"
#include "ljtypes.h"

MPI_Datatype MPI_IDVECTOR;
MPI_Datatype MPI_ATOM; 

MPI_Aint get_mpi_address(void *location) 
{
  MPI_Aint aint;
  MPI_Get_address(location, &aint);   
  return aint;
}

void IdVector_commit()
{
    static int IdVector_commited = 0;
    if (IdVector_commited == 0) {
        struct IdVector idv;
        int len[5] = {3,1,1,1,1};
        MPI_Aint addr[6] = {get_mpi_address(&idv),
                            get_mpi_address(&(idv.v[X])),
                            get_mpi_address(&idv.tag),
                            get_mpi_address(&idv.route),
                            get_mpi_address(&idv.localid),
                            get_mpi_address(&idv.id)};
        MPI_Aint disp[5] = {addr[1]-addr[0],
                            addr[2]-addr[0],
                            addr[3]-addr[0],
                            addr[4]-addr[0],
                            addr[5]-addr[0]};
        MPI_Datatype t[5]= {MPI_DOUBLE,
                            MPI_LONG_LONG,
                            MPI_LONG_LONG,
                            MPI_INT,
                            MPI_LONG_LONG};      
        MPI_Type_create_struct(5,len,disp,t,&MPI_IDVECTOR);
        MPI_Type_commit(&MPI_IDVECTOR); 
        IdVector_commited = 1;
    }
}

void Atom_commit()
{
    static int Atom_commited = 0;
    if (Atom_commited == 0) {
        struct Atom atom;
        int len[4] = {3,3,1,1};
        MPI_Aint addr[5] = {get_mpi_address(&atom),
                            get_mpi_address(&(atom.q[X])),
                            get_mpi_address(&(atom.p[X])),
                            get_mpi_address(&atom.tag),
                            get_mpi_address(&atom.id)};
        MPI_Aint disp[4] = {addr[1]-addr[0],
                            addr[2]-addr[0],
                            addr[3]-addr[0],
                            addr[4]-addr[0]};
        MPI_Datatype t[4]= {MPI_DOUBLE,
                            MPI_DOUBLE,
                            MPI_LONG_LONG,
                            MPI_LONG_LONG};
        MPI_Type_create_struct(4,len,disp,t,&MPI_ATOM);
        MPI_Type_commit(&MPI_ATOM);
        Atom_commited = 1;
    }
}

